"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LiftedIteratorImpl {
    constructor(dispatcher, observable) {
        this.dispatcher = dispatcher;
        this.observable = observable;
    }
    get subscriberCount() {
        return this.observable.subscriberCount;
    }
    dispatch(req) {
        this.dispatcher(req);
    }
    subscribe(subscriber) {
        this.observable.subscribe(subscriber);
    }
}
const liftImpl = (operator, dispatchOperator) => iterator => {
    const observable = iterator.observable || iterator;
    const dispatcher = iterator.dispatcher || ((req) => iterator.dispatch(req));
    const liftedObservable = operator !== undefined ? operator(observable) : observable;
    const liftedDispatcher = dispatchOperator !== undefined
        ? dispatchOperator(dispatcher)
        : dispatcher;
    return new LiftedIteratorImpl(liftedDispatcher, liftedObservable);
};
exports.lift = (operator) => liftImpl(operator, undefined);
exports.liftReq = (operator) => liftImpl(undefined, operator);
//# sourceMappingURL=index.js.map